/*
Copyright 1990-2001 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/
#ifndef _XIMPublic_hh
#define _XIMPublic_hh

#include "IMList.hh"
#include "IMProtocol.hh"

class InputContext;

#include "XIMTriggerKey.h"

class XIMPublic : public IMProtocol {
 public:
  XIMPublic(IMArg*, int);
  ~XIMPublic();

  int set_values(IMArg*, int);
  
  void select_destroy_emask(Window);
  void select_keypress_emask(Window);
  void select_keyrelease_emask(Window);

  void unselect_destroy_emask(Window);
  void unselect_keypress_emask(Window);
  void unselect_keyrelease_emask(Window);

  XIM getXIM();
  const CompoundString &getIfName() const;
  void OpenIM();
  void CloseIM();

  Bool isConversionKey(unsigned int kcode, unsigned int kstate,
		       int convOn);

  Display *getDisplay() const {return display;}

protected:
  IMList<InputContext>  input_context_list;

  Display *display;

  XIMTriggerKeys start_keys;
  XIMTriggerKeys  stop_keys;

  int setSelectionOwner(Window, char*, Atom*);

  enum XIC_RESET_FLAG {
    RESET_NOTHING = 0,
    RESET_BY_CMSG,
    RESET_BY_PROP
  };

  Bool disable_status_area;
private:
  XIM xim;
  XIC root_xic;

  CompoundString ifname; // engine interface module name
  CompoundString application_name; // client_descriptor
  CompoundString default_font_name; // default font name

};

#endif
