/*
Copyright 1990-2001 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/
/*
 * Copyright (c) 1999 Sun Microsystems, Inc.
 * Copyright (c) 1999 Nihon Sun Microsystems K.K.
 * All rights reserved.
 */

#ifndef _CSCONV_H
#define _CSCONV_H

/*
 * "$Id: csconv.h,v 1.1.1.1.2.1 2001/03/15 07:52:17 himi Exp $"
 */

#pragma ident	"@(#)csconv.h 1.5	00/09/14 SMI"

#ifdef	__cplusplus
extern "C" {
#endif


#include <string.h>
#include <sys/types.h>

#if !defined(CSC_BASE_DIR_PERSONAL)
#    define	CSC_BASE_DIR_PERSONAL	"/.iiim/csconv/"
#endif /* !CSC_BASE_DIR_PERSONAL */
#if !defined(CSC_BASE_DIR_SYSTEM)
#    define	CSC_BASE_DIR_SYSTEM	"/etc/lib/im/csconv/"
#endif /* !CSC_BASE_DIR_SYSTEM */
#if !defined(CSC_BASE_DIR_DEFAULT)
#    define	CSC_BASE_DIR_DEFAULT	"/usr/lib/im/csconv/"
#endif /* !CSC_BASE_DIR_DEFAULT */

#define CSC_IS_PATH_ABS(path)	(('/' == *(path)) ||			\
				 (0 == strncmp((path), "./", 2)) ||	\
				 (0 == strncmp((path), "../", 3)))

#define CSC_IS_ANY(ptr, len)	((NULL == (ptr)) ||			\
				 ((1 == (len)) && ('-' == *(ptr))) ||	\
				 ((0 == (len))))

typedef struct _csconv_info *	csconv_t;

extern csconv_t	csconv_open_locale(const char *, const char *, const char *);
extern csconv_t	csconv_open(const char *, const char *);
extern size_t	csconv(csconv_t, const char **, size_t *, char **, size_t *);
extern int	csconv_close(csconv_t);


#ifdef	__cplusplus
}
#endif

#endif /* !_CSCONV_H */
